using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace ConExpress.Utility.DataComponent
{
    /// <summary>
    /// Author: Alex Leo
    /// Email: alexleo321@hotmail.com
    /// Blog: http://www.cnblogs.com/conexpress/
    /// </summary>
    [DefaultProperty("TargetControl")]
    public partial class DataGridViewColumnHeaderEditor : Component, ISupportInitialize
    {
        public DataGridViewColumnHeaderEditor()
        {
            InitializeComponent();
        }

        public DataGridViewColumnHeaderEditor(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
        }

        #region ¼

        /// <summary>
        /// ʼ༭ȡ༭
        /// </summary>
        [Description("ڿʼ༭бʱ¼ȡ༭")]
        public event ColumnHeaderEditEventHandler BeginEdit;

        /// <summary>
        /// ׼༭ȡ
        /// </summary>
        [Description("ڼ༭ʱ¼ȡ")]
        public event ColumnHeaderEditEventHandler EndingEdit;

        /// <summary>
        /// ༭
        /// </summary>
        [Description("ڱ༭¼")]
        public event ColumnHeaderEditEventHandler EndEdit;

        #endregion ¼


        #region ֶκ


        private int m_SelectedColumnIndex = -1;//ѡ
        private int m_ScrollValue = 0;//DataGridViewؼˮƽ
        //еʾжб
        private SortedList<int, DataGridViewColumn> m_SortedColumnList = new SortedList<int, DataGridViewColumn>();


        private DataGridView m_TargetControl = null;
        /// <summary>
        /// Ҫ༭Ŀ DataGridView ؼ
        /// </summary>
        [Description("Ҫ༭Ŀ DataGridView ؼ")]
        public DataGridView TargetControl
        {
            get { return m_TargetControl; }
            set { m_TargetControl = value; }
        }


        private bool m_EnableEdit = true;
        /// <summary>
        /// Ƿ༭
        /// </summary>
        [Description("Ƿ༭"), DefaultValue(true)]
        public bool EnableEdit
        {
            get { return m_EnableEdit; }
            set { m_EnableEdit = value; }
        }

        #endregion ֶκ


        #region ISupportInitialize Ա

        public void BeginInit()
        {
            //޲
        }

        public void EndInit()
        {
            if (m_TargetControl != null)
            {
                this.m_TargetControl.Parent.Controls.Add(this.rtbTitle);
                this.rtbTitle.BringToFront();//RichTextBoxؼǰ
                this.ReloadSortedColumnList();//¼жб
                m_TargetControl.ColumnHeaderMouseDoubleClick += new DataGridViewCellMouseEventHandler(TargetControl_ColumnHeaderMouseDoubleClick);
                m_TargetControl.ColumnDisplayIndexChanged += new DataGridViewColumnEventHandler(TargetControl_ColumnDisplayIndexChanged);
                m_TargetControl.ColumnRemoved += new DataGridViewColumnEventHandler(TargetControl_ColumnRemoved);
                m_TargetControl.ColumnAdded += new DataGridViewColumnEventHandler(TargetControl_ColumnAdded);
                m_TargetControl.Scroll += new ScrollEventHandler(TargetControl_Scroll);
            }
        }

        #endregion ISupportInitialize Ա


        #region Ŀؼ¼

        void TargetControl_Scroll(object sender, ScrollEventArgs e)
        {
            //ֻڲˮƽʱд
            if (e.ScrollOrientation == ScrollOrientation.HorizontalScroll)
            {
                this.m_ScrollValue = e.NewValue;//¼λ

                if (this.rtbTitle.Visible)
                    this.ShowHeaderEdit();//ǰǱ༭״̬ˢʾ༭λ
            }
        }

        void TargetControl_ColumnAdded(object sender, DataGridViewColumnEventArgs e)
        {
            this.ReloadSortedColumnList();//¼жб
        }

        void TargetControl_ColumnRemoved(object sender, DataGridViewColumnEventArgs e)
        {
            this.ReloadSortedColumnList();
        }

        void TargetControl_ColumnDisplayIndexChanged(object sender, DataGridViewColumnEventArgs e)
        {
            this.ReloadSortedColumnList();
        }

        //˫бʾ༭״̬
        void TargetControl_ColumnHeaderMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            this.m_SelectedColumnIndex = this.m_TargetControl.Columns[e.ColumnIndex].DisplayIndex;
            if (this.m_EnableEdit)
                this.ShowHeaderEdit();//ʾ༭״̬
        }

        #endregion Ŀؼ¼


        #region ıط

        /// <summary>
        /// ıļ̴
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rtbTitle_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.Enter://س༭
                    this.m_TargetControl.Focus();//ñ༭ʧȥ༭أͬ
                    e.Handled = true;//Ϊtrueз˵ϵͳʾͬ
                    break;
                case Keys.Right://
                    //жϹǷƶǰ༭ַĩβƵĩβƶ༭
                    if (this.rtbTitle.SelectionStart >= this.rtbTitle.Text.Length)
                    {
                        //жϵǰ༭Ƿһ
                        if (this.m_SelectedColumnIndex < this.m_TargetControl.Columns.Count - 1)
                        {
                            e.Handled = true;
                            this.m_TargetControl.Focus();
                            //ȡһɼеŲΪǰѡ
                            this.m_SelectedColumnIndex = this.GetNextVisibleColumnIndex(this.m_SelectedColumnIndex);
                            this.ShowHeaderEdit();//ѡʾ༭
                        }
                    }
                    break;
                case Keys.Left://
                    //жϹǷ񵽴ﵱǰ༭ַǰƶǰƶ༭
                    if (this.rtbTitle.SelectionStart == 0)
                    {
                        //жϵǰ༭Ƿǵ0
                        if (this.m_SelectedColumnIndex > 0)
                        {
                            e.Handled = true;
                            this.m_TargetControl.Focus();
                            this.m_SelectedColumnIndex = this.GetPreVisibleColumnIndex(this.m_SelectedColumnIndex);
                            this.ShowHeaderEdit();
                        }
                    }
                    break;
                default:
                    break;
            }
        }

        /// <summary>
        /// ıʧȥ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rtbTitle_Leave(object sender, EventArgs e)
        {
            DataGridViewColumn myColumn = this.m_SortedColumnList[this.m_SelectedColumnIndex];
            //¼
            ColumnHeaderEditEventArgs myArgs = new ColumnHeaderEditEventArgs(myColumn, this.rtbTitle.Text.Trim());

            if (this.EndingEdit != null)
            {
                this.EndingEdit(this, myArgs);//¼
                if (myArgs.Cancel)//ȡ־Ϊtrue
                {
                    this.rtbTitle.Focus();//ֱ༭״̬
                    return;
                }
            }

            this.rtbTitle.Visible = false;
            if (myArgs.NewHeaderText.Length > 0)//ÿַΪ
            {
                if (myColumn.HeaderText != myArgs.NewHeaderText)
                {
                    //¼±⣬Ϊ¼޸±
                    myColumn.HeaderText = myArgs.NewHeaderText;
                }
            }

            if (this.EndEdit != null)
                this.EndEdit(this, myArgs);//¼
        }

        /// <summary>
        /// ʾ༭Ч
        /// </summary>
        private void ShowHeaderEdit()
        {
            if (this.BeginEdit != null)
            {
                ColumnHeaderEditEventArgs myArgs = new ColumnHeaderEditEventArgs(this.m_SortedColumnList[this.m_SelectedColumnIndex], "");
                BeginEdit(this, myArgs);
                if (myArgs.Cancel)
                    return;
            }

            int intColumnRelativeLeft = 0;
            //һ߾࣬ҪжǷʾб
            int intFirstColumnLeft = (this.m_TargetControl.RowHeadersVisible ? this.m_TargetControl.RowHeadersWidth + 1 : 1);
            int intTargetX = this.m_TargetControl.Location.X, intTargetY = this.m_TargetControl.Location.Y, intTargetWidth = this.m_TargetControl.Width;

            intColumnRelativeLeft = GetColumnRelativeLeft(this.m_SelectedColumnIndex);

            if (intColumnRelativeLeft < this.m_ScrollValue)
            {
                this.rtbTitle.Location = new Point(intTargetX + intFirstColumnLeft, intTargetY + 1);
                if (intColumnRelativeLeft + this.m_SortedColumnList[this.m_SelectedColumnIndex].Width > this.m_ScrollValue)
                    this.rtbTitle.Width = intColumnRelativeLeft + this.m_SortedColumnList[this.m_SelectedColumnIndex].Width - this.m_ScrollValue;
                else
                    this.rtbTitle.Width = 0;
            }
            else
            {
                this.rtbTitle.Location = new Point(intColumnRelativeLeft + intTargetX - this.m_ScrollValue + intFirstColumnLeft, intTargetY + 1);

                if (this.rtbTitle.Location.X + this.rtbTitle.Width > intTargetX + intTargetWidth)
                {
                    int intWidth = intTargetX + intTargetWidth - this.rtbTitle.Location.X;
                    this.rtbTitle.Width = (intWidth >= 0 ? intWidth : 0);
                }
                else
                    this.rtbTitle.Width = this.m_SortedColumnList[this.m_SelectedColumnIndex].Width;
            }

            this.rtbTitle.Height = this.m_TargetControl.ColumnHeadersHeight - 1;
            this.rtbTitle.Text = this.m_SortedColumnList[this.m_SelectedColumnIndex].HeaderText;
            this.rtbTitle.SelectAll();
            this.rtbTitle.Visible = true;
            this.rtbTitle.Focus();
        }


        #endregion ıط


        #region DataGridViewط

        /// <summary>
        /// ¼жб
        /// </summary>
        private void ReloadSortedColumnList()
        {
            this.m_SortedColumnList.Clear();
            foreach (DataGridViewColumn column in this.m_TargetControl.Columns)
            {
                this.m_SortedColumnList.Add(column.DisplayIndex, column);
            }
        }

        /// <summary>
        /// ȡе߾
        /// </summary>
        /// <param name="ColumnIndex"></param>
        /// <returns>е߾</returns>
        private int GetColumnRelativeLeft(int ColumnIndex)
        {
            int intLeft = 0;
            DataGridViewColumn Column = null;

            for (int intIndex = 0; intIndex < ColumnIndex; intIndex++)
            {
                if (this.m_SortedColumnList.ContainsKey(intIndex))
                {
                    Column = this.m_SortedColumnList[intIndex];
                    if (Column.Visible)
                        intLeft += Column.Width + Column.DividerWidth;
                }
            }

            return intLeft;
        }

        /// <summary>
        /// ȡһɼе
        /// </summary>
        /// <param name="CurrentIndex">ǰ</param>
        /// <returns></returns>
        private int GetPreVisibleColumnIndex(int CurrentIndex)
        {
            int intPreIndex = 0;

            for (int intIndex = CurrentIndex - 1; intIndex >= 0; intIndex--)
            {
                if (this.m_SortedColumnList.ContainsKey(intIndex) && this.m_SortedColumnList[intIndex].Visible)
                {
                    intPreIndex = intIndex;
                    break;
                }
            }

            return intPreIndex;
        }

        /// <summary>
        /// ȡһɼе
        /// </summary>
        /// <param name="CurrentIndex">ǰ</param>
        /// <returns></returns>
        private int GetNextVisibleColumnIndex(int CurrentIndex)
        {
            int intNextIndex = CurrentIndex;

            for (int intIndex = CurrentIndex + 1; intIndex <= this.m_SortedColumnList.Keys[this.m_SortedColumnList.Count - 1]; intIndex++)
            {
                if (this.m_SortedColumnList.ContainsKey(intIndex) && this.m_SortedColumnList[intIndex].Visible)
                {
                    intNextIndex = intIndex;
                    break;
                }
            }

            return intNextIndex;
        }


        #endregion DataGridViewط


    }//class DataGridViewColumnHeaderEditor

    /// <summary>
    /// б༭¼ί
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public delegate void ColumnHeaderEditEventHandler(object sender, ColumnHeaderEditEventArgs e);

    /// <summary>
    /// б༭¼
    /// </summary>
    public class ColumnHeaderEditEventArgs : EventArgs
    {
        private bool m_Cancel = false;
        /// <summary>
        /// ȡ༭
        /// </summary>
        public bool Cancel
        {
            get { return m_Cancel; }
            set { m_Cancel = value; }
        }

        private string m_NewHeaderText = "";
        /// <summary>
        /// µб
        /// </summary>
        public string NewHeaderText
        {
            get { return m_NewHeaderText; }
            set
            {
                if (!(string.IsNullOrEmpty(value) || value.Trim().Length == 0))
                    m_NewHeaderText = value;
            }
        }

        private DataGridViewColumn m_Column = null;
        /// <summary>
        /// Ŀ
        /// </summary>
        public DataGridViewColumn Column
        {
            get { return m_Column; }
        }

        public ColumnHeaderEditEventArgs(DataGridViewColumn Column, string NewHeaderText)
        {
            if (Column == null)
                throw new ArgumentNullException("Column", "Ҫ༭вΪա");

            this.m_Column = Column;

            if (string.IsNullOrEmpty(NewHeaderText) || NewHeaderText.Trim().Length == 0)
                NewHeaderText = Column.HeaderText;

            this.m_NewHeaderText = NewHeaderText.Trim();
        }
    }//class ColumnHeaderEditEventArgs

}
